

//终端类型与浏览器内核判断
var browser={    
versions:function(){            
var u = navigator.userAgent, app = navigator.appVersion;            
return {                
	trident: u.indexOf('Trident') > -1, //IE内核
    presto: u.indexOf('Presto') > -1, //opera内核
    webKit: u.indexOf('AppleWebKit') > -1, //苹果、谷歌内核
    gecko: u.indexOf('Gecko') > -1 && u.indexOf('KHTML') == -1,//火狐内核
    mobile: !!u.match(/AppleWebKit.*Mobile.*/), //是否为移动终端
     ios: !!u.match(/\(i[^;]+;( U;)? CPU.+Mac OS X/), //ios终端
            android: u.indexOf('Android') > -1 || u.indexOf('Linux') > -1, //android终端或者uc浏览器
            iPhone: u.indexOf('iPhone') > -1 , //是否为iPhone或者QQHD浏览器
            iPad: u.indexOf('iPad') > -1, //是否iPad
            webApp: u.indexOf('Safari') == -1 //是否web应该程序，没有头部与底部            
};
}()
} 


var LittleUrl = {
    // public method for url encoding
    encode : function (string) {
        return escape(this._utf8_encode(string));
    },
    // public method for url decoding
    decode : function (string) {
        return this._utf8_decode(unescape(string));
    },
    // private method for UTF-8 encoding
    _utf8_encode : function (string) {
        string = string.replace(/\r\n/g,"\n");
        var utftext = "";
        for (var n = 0; n < string.length; n++) {
 
            var c = string.charCodeAt(n);
 
            if (c < 128) {
                utftext += String.fromCharCode(c);
            }
            else if((c > 127) && (c < 2048)) {
                utftext += String.fromCharCode((c >> 6) | 192);
                utftext += String.fromCharCode((c & 63) | 128);
            }
            else {
                utftext += String.fromCharCode((c >> 12) | 224);
                utftext += String.fromCharCode(((c >> 6) & 63) | 128);
                utftext += String.fromCharCode((c & 63) | 128);
            }
 
        }
 
        return utftext;
    },
 
    // private method for UTF-8 decoding
    _utf8_decode : function (utftext) {
        var string = "";
        var i = 0;
        var c = c1 = c2 = 0;
 
        while ( i < utftext.length ) {
 
            c = utftext.charCodeAt(i);
 
            if (c < 128) {
                string += String.fromCharCode(c);
                i++;
            }
            else if((c > 191) && (c < 224)) {
                c2 = utftext.charCodeAt(i+1);
                string += String.fromCharCode(((c & 31) << 6) | (c2 & 63));
                i += 2;
            }
            else {
                c2 = utftext.charCodeAt(i+1);
                c3 = utftext.charCodeAt(i+2);
                string += String.fromCharCode(((c & 15) << 12) | ((c2 & 63) << 6) | (c3 & 63));
                i += 3;
            }
        }
        return string;
    }
}


/** 
 html应用向“壳”反馈信息 
@param jsondata 请求携带数据,格式：{sid:, operate:,data:}  //升级“{\“sid\”:\”a11\”,\”operate\”:\”update\”,\”data\”:{\“appid\”:\”b12\”,\”url\”:\”\”}}”)
*/
function shell_Req(jsondata){
    // console.info(jsondata);
	if(browser.versions.ios){//ios终端
		shell_IosReq(jsondata);
	}else if(browser.versions.android){//android 终端
		shell_AndroidReq(jsondata);
	}else if(browser.versions.trident){//phone8 终端（不是很准确，需进一步细化）
		shell_WpReq(jsondata);
	}else{//全部当作浏览器调试，这里处理处理开发过程中的调试逻辑
		shell_TestReq(jsondata);
		shell_IosReq(jsondata);
	}
}

//回退的web应用外
function shell_Back(){
	if(browser.versions.ios){//ios终端
		shell_IosBack();
	}else if(browser.versions.android){//android 终端
		shell_AndroidBack();
	}else if(browser.versions.trident){//phone8 终端（不是很准确，需进一步细化）
		shell_WpBack();
	}else{//全部当作浏览器调试，这里处理处理开发过程中的调试逻辑
		shell_TestBack();
	}
}

//退出程序
function shell_Exit(){
	window.location = "protocol://exit";
if(browser.versions.ios){//ios终端
		shell_IosExit();
	}else if(browser.versions.android){//android 终端
		shell_AndroidExit();
	}else if(browser.versions.trident){//phone8 终端（不是很准确，需进一步细化）
		shell_WpExit();
	}else{//全部当作浏览器调试，这里处理处理开发过程中的调试逻辑
		shell_TestExit();
	}
}


/**
 * 根据给定的url，进行下载处理
 * @method wq_UpdateWithUrl
 * @param updateUrl  升级包下载地址，如空则选用配置文件中的升级地址
 * @param flag 升级标志 0-覆盖升级 1-增量升级 2-全新升级（清除原来文件，在解压新包）
 * @return 无（异步方式反馈升级结果标志）
 */
function shell_UpdateWithUrl(appid,updateUrl,flag){
	if(browser.versions.ios){//ios终端
		shell_IosUpdateWithUrl();
	}else if(browser.versions.android){//android 终端
		shell_AndroidUpdateWithUrl();
	}else if(browser.versions.trident){//phone8 终端（不是很准确，需进一步细化）
		shell_WpUpdateWithUrl();
	}else{//全部当作浏览器调试，这里处理处理开发过程中的调试逻辑
		shell_TestUpdateWithUrl();
	}
}


function shell_TestReq(jsondata){
	var alertstr = "请求的数据：";
	alertstr +=  jsondata;
 	alert(alertstr);
}

function shell_TestUpdateWithUrl(){
	alert("update success!");
}


function shell_TestBack(){
	alert("you have gone back!");
}


function shell_TestExit(){
	alert("you have exited!");
}

