var showProductList = [
    {title:"货币基金", type:31, link:"HBJJ_FIND.json", cornerLabelClass:"cornerLabelNew", cornerLabel:"HOT", centerDescription:"随存随取，年化收益超活期<emphasize>15</emphasize>倍", rightDescription:"人气值", baseNumber:2500, randomRange:1000, functionPoint:"922600410003"},
    {title:"债券基金", type:31, link:"ZQJJ_FIND.json", cornerLabelClass:"cornerLabel", cornerLabel:"10+", centerDescription:"稳健上涨，安全理财，靠谱收益选债基", rightDescription:"人气值", baseNumber:2000, randomRange:500, functionPoint:"922600410004"},
    {title:"指数基金", type:31, link:"ZSJJ_FIND.json", cornerLabelClass:"cornerLabelNew", cornerLabel:"NEW", centerDescription:"牛市行情，指基为王，涨了指数就赚钱", rightDescription:"人气值", baseNumber:1000, randomRange:600, functionPoint:"922600410005"},
    {title:"股票基金", type:31, link:"GPJJ_FIND.json", cornerLabelClass:"cornerLabel", cornerLabel:"10+", centerDescription:"明星基金经理操盘，近一年赚超<emphasize>95%</emphasize>", rightDescription:"人气值", baseNumber:700, randomRange:500, functionPoint:"922600410006"},
    // {title:"理财大全", type:85, link:"", cornerLabelClass:"cornerLabel", cornerLabel:"", centerDescription:"基金排名、银行理财，品种全覆盖", rightDescription:"人气值", baseNumber:700, randomRange:500, functionPoint:""},
];

//初始化单页4个页面
function reBuildHtml(){
    for (var index in showProductList){
        var htmlText =
            '<div id="cornerLabel'+index+'" class="'+showProductList[index].cornerLabelClass+'">'+showProductList[index].cornerLabel+'&nbsp;&nbsp;</div>'+
            '<div id="leftPart'+index+'" class="leftPart">'+
                '<div class="titleContainer">'+
                    '<div class="title">'+showProductList[index].title+'</div>'+
                '</div>'+
            '</div>'+
            '<div class="centerPart">'+
                '<div class="separator"></div>'+
                '<div class="descriptionContainer">'+
                    '<p class="centerDescription">'+showProductList[index].centerDescription+'</p>'+
                '</div>'+
            '</div>'+
            // '<div class="rightPart">'+
            //     '<div id="rightTopLabel'+index+'" class="rightTopLabel"></div>'+
            //     '<div class="rightBottomLabel">'+showProductList[index].rightDescription+'</div>'+
            // '</div>'+
            '<div class="rightArrow"></div>'
        var condition = '#cell'+index;
        $(condition).html(htmlText);
    }
}

//计算每个cell的随机人数
function calculateNumber(){
    for (var index in showProductList){
        var num = showProductList[index].baseNumber+Math.round(Math.random()*showProductList[index].randomRange);
        var condition = '#rightTopLabel'+index;
        $(condition).html(num);
    }
}

//初始化点击事件
function initClick(){
    for(var index in showProductList){
        var condition = '#cell'+index;
        $(condition).on("click", function (e){
            e.stopPropagation();
            var num = this.getAttribute('id');
            try{
                var i = num.substring(num.length-1,num.length);
                var params = '{"type":'+showProductList[i].type+',"title":"'+showProductList[i].title+'","link":"'+showProductList[i].link+'","functionPoint":"'+showProductList[i].functionPoint+'"}';
                shell_Req(params);
            }catch(e){
            }
        });
    }
}

function initlocalhtml() {
    //如果本地支持Html5缓存，并且有存储值得话，更新收益率
    if (localStorage && localStorage.getItem("FindData")) {
        // console.info('localStorage');
        refreshAJAXData(eval("(" + localStorage.getItem("FindData") + ")"));
    }
    //请求服务器获取最新的收益率
    requestRemote();
}

function requestRemote() {
    $.ajax({
        url: "http://180.96.8.92:8083/jfire/app/find.do",
        type: 'GET',
        cache: false,
        dataType: 'jsonp',
        jsonp: 'callback',
        success: function (result) {
            // console.info('success result:'+result);
            refreshAJAXData(result);
        },
        error: function (XMLHttpRequest, textStatus, errorThrown) {
            // console.info('error result:'+errorThrown);
        }
    });
}

function refreshAJAXData(result) {
    if (null == result || typeof result == 'undefined') {
        return;
    }
    for (var index in result) {
        if (result[index].value == undefined){continue;}
        var findValue = result[index].value;
        // console.info(findValue);
        if (findValue) {
            var condition = '#rightTopLabel'+index;
            $(condition).html(findValue);
        }
    }
    localStorage.setItem("FindData", JSON.stringify(result));
}
