/**
 * Created by hyu.Yale on 2015/11/13.
 */
/**
 * 根据WindCode加载页面数据
 * @param windCode 基金的WindCode
 */
function loadPage(windCode) {
    if (window.windCode == undefined || window.windCode != windCode) {
        window.windCode = windCode;
    }
    loading();
    loadCache();
    ajaxRequest();
}

function loading() {
    $("#loadStatus_lay").hide();
    $("#loading_lay").show();
}
function loadingFinish() {
    $("#loading_lay").fadeOut(500);
    $("#loadStatus_lay").fadeOut(500);
}

Session.isCurrencyFund = function (type) {
    return type == '01';
}

Session.fundType = function () {
    return Session.topInfo.fundType;
}

/**
 * 加载基金缓存
 */
function loadCache() {
    try {
        QueryHelper(window.windCode, CMD_CODE[0], function (value) {
            if (undefined != value) {
                var parsedObj = parserObject(value.data.messageBody);
                loadBasePage(parsedObj);
            }
        });

        QueryHelper(window.windCode, CMD_CODE[2] + "01", function (value) {
            if (undefined != value) {
                var parsedObj = parserObject(value.data.messageBody);
                loadTrend(parsedObj, "01");
            }
        });
    } catch (e) {
    }
}


/**
 * 客户端准备分享参数
 */
function onShare() {
    try {
        if (Session.topInfo && Session.shareInfo && Session.shareInfo.length > 0) {
            var params = {
                type: 209,
                data: {windName: fixString(Session.topInfo.windName), shareInfo: Session.shareInfo}
            };
            shell_Req(JSON.stringify(params))
        }
    } catch (e) {
    }
}

/**
 * 加载失败提示
 */
function loadBaseFailed() {
    loadError();
}

/**
 * 加载基础页面
 * @param parsedObj 解析过的数据项
 */
function loadBasePage(parsedObj) {
    loadingFinish();

    $("#hide_showing").val(true);

    Session.topInfo = parsedObj.topInfo;

    Session.operationInfo = parsedObj.operationInfo;
    Session.productArchive = parsedObj.productArchive;
    Session.rating = parsedObj.productArchive;
    Session.sectionShow = parsedObj.sectionShow;
    Session.shareInfo = parsedObj.shareInfo;

    //告知客户端存储分享的数据，仅仅是存储
    onShare();

    if (window.trendDrawer) {
        window.trendDrawer.setTopEl(prepareTrendTopInfo("01"));
        window.trendDrawer.reRender();
    }

    //顶部信息
    createTopLay();
    showTopInfo();

    //广告栏位
    if (Session.operationInfo && Session.operationInfo.operationDesc) {
        if (localStorage) {
            var obj = localStorage.getItem(window.windCode + "banner");
            if (Session.operationInfo.id == obj) {
                //此广告不需要再次展现
            } else {
                createBannerLay();
                showBanner();
            }
        }
    }

    if (Session.isCurrencyFund(Session.topInfo.fundType)) {
        Session.areaChart = parsedObj.areaChart;
        createCurrencyTrendCanvas();
        showCurFundTrend();
    } else {
        createTrendCanvas();
    }

    //阶段表现
    createStageLay();
    showFundStage();

    //产品档案
    createAndShowProductDocLay(Session.productArchive);

    $(".pullUpLabel").html("继续拖动，查看产品详情");
}

/**
 * 加载额外信息页面（第二页）
 * @param parsedObj 解析过的数据项
 */
function loadExtraPage(parsedObj) {
    //继续拖动查看详情功能点统计
    submitFunction("922400050011");

    Session.assetsConfigInfo.assetAllocation = parsedObj.assetsConfigInfo.assetAllocation;
    Session.assetsConfigInfo.industryInfo = parsedObj.assetsConfigInfo.industryInfo;
    Session.assetsConfigInfo.bondTypeInfo = parsedObj.assetsConfigInfo.bondTypeInfo;
    Session.assetsConfigInfo.countryInfo = parsedObj.assetsConfigInfo.countryInfo;

    Session.companyInfo = parsedObj.companyInfo;
    Session.fundScaleList = parsedObj.fundScaleList;
    Session.managerInfo = parsedObj.managerInfo;
    Session.holdingStock = parsedObj.holdingStock;
    Session.bankList = parsedObj.bankList;

    //测试数据
    //Session.fundScaleList = [{
    //    "FundScale": "5.35",
    //    "PurchaseRedeemNetAccount": "",
    //    "QuarterName": "14Q3",
    //    "WindCode": "400022.OF"
    //},{
    //    "FundScale": "14.35",
    //    "PurchaseRedeemNetAccount": "",
    //    "QuarterName": "11Q3",
    //    "WindCode": "400032.OF"
    //}]
    //Session.fundScaleList = [
    //    {
    //        "FundScale": "0.2122",
    //        "PurchaseRedeemNetAccount": "383.646",
    //        "QuarterName": "14Q3",
    //        "WindCode": "000049.OF"
    //    },
    //    {
    //        "FundScale": "0.2552",
    //        "PurchaseRedeemNetAccount": "718.854",
    //        "QuarterName": "14Q4",
    //        "WindCode": "000049.OF"
    //    },
    //    {
    //        "FundScale": "0.2328",
    //        "PurchaseRedeemNetAccount": "-144.3206",
    //        "QuarterName": "15Q1",
    //        "WindCode": "000049.OF"
    //    },
    //    {
    //        "FundScale": "0.1777",
    //        "PurchaseRedeemNetAccount": "--",
    //        "QuarterName": "15Q2",
    //        "WindCode": "000049.OF"
    //    }
    //];
    //规模变化,一条数据不显示
    if (Session.fundScaleList && Session.fundScaleList.length > 1) {
        //新增数据内容校验，后台返回的数据也不能保证其都是正确的
        var validCount = 0;
        $.each(Session.fundScaleList, function (index, el) {
            if (!isNaN(el.FundScale)) {
                validCount++;
            }
        });
        if (validCount > 1) {
            createScaleLay();
            showScaleInfo();
        }
    }

    //资产配置
    createAssetPieLay();

    //重仓持股
    if (Session.holdingStock) {
        //新模式，待服务升级后可用
        if (Session.holdingStock.holdingStockName) {
            if (Session.holdingStock.items && Session.holdingStock.items.length > 0) {
                createHoldingStockLay();
                showHoldStockList();
                $("#assets_lay_name").html(Session.holdingStock.holdingStockName);
            }
        } else {
            if (Session.holdingStock.length > 0) {
                createHoldingStockLay();
                showHoldStockList();
                $("#assets_lay_name").html("重仓持股");
            }
        }
    }

    //基金经理
    createAndShowManager(parsedObj.managerInfo);

    //基金公司
    if (Session.companyInfo) {
        createManagerCompanyLay();
        showCompanyInfo();
    }

    //支持的银行
    if(Session.bankList){
        showBankList(Session.bankList);
    }

    animateNextPage();
}


/**
 * 动画展现第二页数据
 */
function animateNextPage() {
    $("#content_lay2").show().attr("showing", true);
    $("#pullUp").hide();
    myScroll.refresh();
    myScroll.scrollToElement(document.getElementById("content_lay2"));
    animatePie();
}

function showTopInfo() {
    var fundAttr = {
        "flag": {type: "", risk: "", purLimit: "", save: ""},
        "attr": [{key: "", value: ""}, {key: "", value: ""}, {key: "", value: ""}]
    };
    fundAttr.type = fixString(Session.topInfo.firstInvestType);
    fundAttr.risk = fixString(Session.topInfo.riskAttribute);
    fundAttr.purLimit = fixString(Session.topInfo.purchaseLimitMinDesc);
    fundAttr.save = fixString(Session.topInfo.redeemToAccDesc);

    if (Session.isCurrencyFund(Session.topInfo.fundType)) {
        fundAttr.attr[0].key = "万份收益";
        fundAttr.attr[0].value = fixNum(Session.topInfo.mmfUnitYield, 4);

        fundAttr.attr[1].key = "七日年化";
        fundAttr.attr[1].value = fixNum(Session.topInfo.mmfAnnualizedYield, 2, true);

        fundAttr.attr[2].key = "净值日期";
        fundAttr.attr[2].value = formatNavDate(Session.topInfo.navDate);
    } else {
        fundAttr.attr[0].key = "最新净值";
        fundAttr.attr[0].value = fixNum(Session.topInfo.navUnit, 4);

        fundAttr.attr[1].key = "日涨幅";
        fundAttr.attr[1].value = fixNum(Session.topInfo.navIncrease, 2, true);

        fundAttr.attr[2].key = "净值日期";
        fundAttr.attr[2].value = formatNavDate(Session.topInfo.navDate);
    }

    $("#top_list_first_key").html(fundAttr.attr[0].key);
    $("#top_list_first_value").html(fixString(fundAttr.attr[0].value));

    $("#top_list_second_key").html(fundAttr.attr[1].key);

    var upDownStatus = checkUpOrDown(fundAttr.attr[1].value);
    if (upDownStatus == STATUS[0]) {
        $("#top_list_second_value").addClass("red-color").html(fixStringRate(fundAttr.attr[1].value, 2));
    } else if (upDownStatus == STATUS[2]) {
        $("#top_list_second_value").addClass("green-color").html(fixStringRate(fundAttr.attr[1].value, 2));
    } else {
        $("#top_list_second_value").html(fixStringRate(fundAttr.attr[1].value, 2));
    }

    $("#top_list_third_key").html(fundAttr.attr[2].key);
    $("#top_list_third_value").html(fundAttr.attr[2].value);

    $("#fund_top_type").html(fundAttr.type);
    $("#fund_top_risk").html(fundAttr.risk);
    $("#fund_top_limit").html(fundAttr.purLimit);
    $("#fund_top_save").html(fundAttr.save);
}
function showBanner() {
    $("#banner").html(Session.operationInfo.operationDesc);
}

function showFundStage() {
    var buffer = new StringBuffer();
    $.each(Session.sectionShow, function (index, el) {
        //标题头
        if (index == 0) {
            buffer.append("<ul class='fund-stage-title'>");
        } else {
            buffer.append("<ul class='fund-stage-data-ul'>");
        }
        buffer.append("<li>" + fixString(el.clomnName) + "</li>")

        var status = checkUpOrDown(el.seflFund);
        if (status == STATUS[0]) {
            buffer.append("<li class='second-child red-color'>" + fixStringRate(el.seflFund) + "</li>")
        } else if (status == STATUS[2]) {
            buffer.append("<li class='second-child green-color'>" + fixStringRate(el.seflFund) + "</li>")
        } else {
            buffer.append("<li class='second-child dark-color'>" + fixStringRate(el.seflFund) + "</li>")
        }

        if ("" == el.ranking.trim()) {
            el.ranking = "--";
        }
        if (index == 0) {
            buffer.append("<li id='sortColumn'>" + fixString(el.sameFund) + "<img class='ranking-sort' src='./style/images/arrow_change_ranking.png'/></li>")
            buffer.append("<li id='sortId' tag='same'>" + el.ranking + "</li>")
        } else {
            var status = checkUpOrDown(el.sameFund);
            if (status == STATUS[0]) {
                buffer.append("<li class='canSorted red-color fund-stage-third' tag='column" + index + "'>" + fixStringRate(el.sameFund) + "</li>");
            } else if (status == STATUS[2]) {
                buffer.append("<li class='canSorted green-color fund-stage-third' tag='column" + index + "'>" + fixStringRate(el.sameFund) + "</li>");
            } else {
                buffer.append("<li class='canSorted fund-stage-third' tag='column" + index + "'>" + fixStringRate(el.sameFund) + "</li>");
            }

            var rankTxt = fixString(el.ranking);
            var index = rankTxt.indexOf("/");
            if (index > 0) {
                buffer.append("<li><span class='dark-color'>" + rankTxt.substr(0, index) + "</span><span class='rank-small'>" + rankTxt.substr(index, rankTxt.length - 1) + "</span></li>");
            } else {
                buffer.append("<li>" + fixString(el.ranking) + "</li>");
            }

        }
        buffer.append("</ul>");
    });
    $("#fund_stage").html(buffer.toString());

    $("#sortColumn").on("touchend", function (e) {
        changeSimalarHs300();
        e.preventDefault();
    });
}

function changeSimalarHs300() {
    try {
        var tag = $("#sortId").attr("tag");
        submitFunction("922400050024");
        if ("same" == tag) {
            $.each($(".canSorted"), function (index, el) {
                var showValue = Session.sectionShow[index + 1].hs300;
                var status = checkUpOrDown(showValue);
                if (status == STATUS[0]) {
                    $(el).removeClass("green-color").addClass("red-color");
                } else if (status == STATUS[2]) {
                    $(el).removeClass("red-color").addClass("green-color");
                } else {
                    $(el).removeClass("red-color").removeClass("green-color");
                }
                $(el).html(fixStringRate(showValue));
            })
            $("#sortId").attr("tag", "hs300");
            //$("#sortId img").attr("src", "./style/images/arrow_up_small.png");
            $("#sortColumn").html(fixString(Session.sectionShow[0].hs300) + "<img class='ranking-sort' src='./style/images/arrow_change_ranking.png'/>");
        } else if ("hs300" == tag) {
            $.each($(".canSorted"), function (index, el) {
                var showValue = Session.sectionShow[index + 1].sameFund;
                var status = checkUpOrDown(showValue);
                if (status == STATUS[0]) {
                    $(el).removeClass("green-color").addClass("red-color");
                } else if (status == STATUS[2]) {
                    $(el).removeClass("red-color").addClass("green-color");
                } else {
                    $(el).removeClass("red-color").removeClass("green-color");
                }
                $(el).html(fixStringRate(showValue));
            })
            $("#sortId").attr("tag", "same");
            //$("#sortId img").attr("src", "./style/images/arrow_down_small.png");
            $("#sortColumn").html(fixString(Session.sectionShow[0].sameFund) + "<img class='ranking-sort' src='./style/images/arrow_change_ranking.png'/>");
        }
    } catch (e) {
    }
}

function showCompanyInfo() {
    //基金公司全称
    $("#fund_company_name").html(fixString(Session.companyInfo.CorpName));
    //旗下多少只基金
    $(".company-count").html(fixString(Session.companyInfo.FundNo));
    //成立日期
    $("#CorpSetupDate").html(fixString(Session.companyInfo.CorpSetupDate));
    //总规模
    var tempScale = fixString(fixNum(Session.companyInfo.CorpScale, 2));
    if (tempScale != "--") {
        $("#CorpScale").html(tempScale + "亿元");
    } else {
        $("#CorpScale").html(tempScale);
    }

    //总经理
    $("#CorpManager").html(fixString(Session.companyInfo.CorpManager));
    //规模排名
    $("#CorpRanking").html(fixString(Session.companyInfo.CorpRanking));
    //旗下基金经理
    $("#FundManagersNo").html(fixString(Session.companyInfo.FundManagersNo));
    //基金经理平均年限
    $("#AverageWorkYear").html(fixString(fixNum(Session.companyInfo.AverageWorkYear, 2)));
}

function showScaleInfo() {
    var dataList = [];
    //Session.fundScaleList = [
    //    {
    //        "FundScale": "0.02",
    //        "PurchaseRedeemNetAccount": "",
    //        "QuarterName": "15Q3",
    //        "WindCode": "001904.OF"
    //    },
    //    {
    //        "FundScale": "0.02",
    //        "PurchaseRedeemNetAccount": "",
    //        "QuarterName": "15Q4",
    //        "WindCode": "001904.OF"
    //    }
    //],
    $.each(Session.fundScaleList, function (index, el) {
        if (!isNaN(el.FundScale)) {
            dataList.push({
                txt: fixString(fixNum(el.FundScale, 2)) + "亿",
                barBottomTxt: el.QuarterName,
                value: fixNum(el.FundScale, 2)
            });
        }
    });

    if (window.fundScaleDrawer == undefined) {
        window.fundScaleDrawer = new ScaleDrawer("fund_scale");
    } else {
        window.fundScaleDrawer.clear()
    }
    window.fundScaleDrawer.draw(dataList, true)
}

function showHoldStockList() {
    var dataList = new Array();
    if (Session.holdingStock.holdingStockName) {
        $.each(Session.holdingStock.items, function (index, el) {
            dataList.push({
                name: "" + el.stockName + "",
                rate: el.stockToNav,
                rateTxt: parseFloat(el.latest3MonthBenifit).toFixed(2),
                upTxt: checkUpOrDown(el.latest3MonthBenifit),
                up: checkUpOrDown(el.stockToNavFloat)
            });
        })
    } else {
        $.each(Session.holdingStock, function (index, el) {
            dataList.push({
                name: "" + el.stockName + "",
                rate: el.stockToNav,
                rateTxt: parseFloat(el.latest3MonthBenifit).toFixed(2),
                upTxt: checkUpOrDown(el.latest3MonthBenifit),
                up: checkUpOrDown(el.stockToNavFloat)
            });
        })
    }
    window.assetsBarDrawer = new HoldingStock("assetBar");
    assetsBarDrawer.draw(dataList);
}

function showBankList(bankList) {
    createAndShowBankLay(bankList);
}

/**
 * 加载基础页面
 * @param parsedObj 解析过的数据项
 */
function loadTrend(parsedObj, type) {
    if (parsedObj && parsedObj.dataList && parsedObj.dataList.length > 0) {
        if (Session.isCurrencyFund(parsedObj.fundType) || parsedObj.dataList[0].MmfAnnualizedYield) {
            createCurrencyTrendCanvas();
            if (( $('#hide_trend_tag').val() == "04") && (window.scaleDrawer != undefined)) {
                loadTrendData(true, parsedObj.dataList, type);
            }
        } else {
            if (1 == $("#fund_trend").length) {
                loadTrendData(false, parsedObj.dataList, type);
            } else {
                createTrendCanvas();
                loadTrendData(false, parsedObj.dataList, type);
            }
        }
    }
}

/**
 * 加载非货币基金趋势图数据
 * @param parsedObj 非货基数据
 */
function loadTrendData(flag, parsedObj, type) {
    if (!flag) {
        Session.trendData = parsedObj;
        if (undefined != Session.trendData && Session.trendData.length > 0) {
            hideTrendLoading();
            var minArr = [1000000, 1000000, 1000000];
            var maxArr = [-1000000, -1000000, -1000000];
            //找出最大最小值
            var parserValue;
            $.each(Session.trendData, function (index, el) {
                if (!isNaN(el.Nav)) {
                    parserValue = parseFloat(el.Nav);
                    if (parserValue > maxArr[0]) {
                        maxArr[0] = parserValue;
                    }
                    if (parserValue < minArr[0]) {
                        minArr[0] = parserValue;
                    }
                }
                if (!isNaN(el.SimFundAvgReturn)) {
                    parserValue = parseFloat(el.SimFundAvgReturn);
                    if (parserValue > maxArr[1]) {
                        maxArr[1] = parserValue;
                    }
                    if (parserValue < minArr[1]) {
                        minArr[1] = parserValue;
                    }
                }
                if (!isNaN(el.Hs300AvgReturn)) {
                    parserValue = parseFloat(el.Hs300AvgReturn);
                    if (parserValue > maxArr[2]) {
                        maxArr[2] = parserValue;
                    }
                    if (parserValue < minArr[2]) {
                        minArr[2] = parserValue;
                    }
                }
            });

            var maxValue = maxArr[0];
            var minValue = minArr[0];

            $.each(maxArr, function (index, el) {
                if (el > maxValue) {
                    maxValue = el
                }
            });
            $.each(minArr, function (index, el) {
                if (el < minValue) {
                    minValue = el
                }
            });

            if (undefined == window.trendDrawer) {
                window.trendDrawer = new TrendDrawer("trend", onDataBack);
            }

            trendDrawer.drawTrend(type, Session.trendData, maxValue, minValue, true, prepareTrendTopInfo(type));
            trendDrawer.canvas.addEventListener('touchstart', touchHandler, false);
            trendDrawer.canvas.addEventListener('touchmove', touchHandler, false);
            trendDrawer.canvas.addEventListener('touchend', touchHandler, false);
        }
    } else {
        if (undefined != parsedObj && parsedObj.length > 0) {
            hideTrendLoading();
            var minArr = [1000000, 1000000];
            var maxArr = [-1000000, -1000000];
            //找出最大最小值
            var parserValue;
            $.each(parsedObj, function (index, el) {
                if (!isNaN(el.MmfAnnualizedYield)) {
                    parserValue = parseFloat(el.MmfAnnualizedYield);
                    if (parserValue > maxArr[0]) {
                        maxArr[0] = parserValue;
                    }
                    if (parserValue < minArr[0]) {
                        minArr[0] = parserValue;
                    }
                }
                if (!isNaN(el.MmfUnitYield)) {
                    parserValue = parseFloat(el.MmfUnitYield);
                    if (parserValue > maxArr[1]) {
                        maxArr[1] = parserValue;
                    }
                    if (parserValue < minArr[1]) {
                        minArr[1] = parserValue;
                    }
                }
            });
            var element = undefined;
            if (Session.topInfo && Session.topInfo.totalUnitYield && Session.topInfo.avgannualizedYield) {
                element = {
                    NavDate: "近一年",
                    MmfUnitYield: Session.topInfo.totalUnitYield,
                    MmfAnnualizedYield: Session.topInfo.avgannualizedYield
                };
            }
            scaleDrawer.drawTrend(parsedObj, maxArr, minArr, true, element);
            scaleDrawer.canvas.addEventListener('touchstart', fundTouchHandler, false);
            scaleDrawer.canvas.addEventListener('touchmove', fundTouchHandler, false);
            scaleDrawer.canvas.addEventListener('touchend', fundTouchHandler, false);
        }
    }
}

/**
 * 显示货币基金走势图
 */
function showCurFundTrend() {
    if (Session.areaChart) {
        hideTrendLoading();
        var dataList = [
            {
                txt: Session.areaChart.currFundDeposit + "倍",
                barBottomTxt: "本基金",
                value: Session.areaChart.currFundDeposit
            },
            {
                txt: Session.areaChart.demandDeposit + "倍",
                barBottomTxt: "活期利率",
                value: Session.areaChart.demandDeposit
            },
            {txt: Session.areaChart.termDeposit + "倍", barBottomTxt: "一年定存", value: Session.areaChart.termDeposit}
        ];
        if (window.scaleDrawer == undefined) {
            window.scaleDrawer = new ScaleDrawer("cur_trend");
        } else {
            window.scaleDrawer.clear();
        }
        window.scaleDrawer.draw(dataList);
    }
}

function onDataBack(curFund, similarFund, hs300Fund) {
    //$("#curFund").html(curFund);
    //$("#similarFund").html(similarFund);
    //$("#hs300Fund").html(hs300Fund);
}

function fundTouchHandler(event) {
    if (scaleDrawer) {
        if (scaleDrawer.mCanvasType != "trend") {
            return;
        }
        var event = event || window.event;
        switch (event.type) {
            case "touchstart":
                submitFunction("922400050022");
                break;
            case "touchend":
                window.scaleDrawer.reRender();
                break;
            case "touchmove":
                event.preventDefault();
                window.scaleDrawer.drawReticle(event.touches[0].clientX);
                break;
        }
    }
}
function touchHandler(event) {
    if ($('#hide_trend_tag').val() != trendDrawer.mType) {
        return;
    }
    if (trendDrawer) {
        var event = event || window.event;
        switch (event.type) {
            case "touchstart":
                submitFunction("922400050021");
                break;
            case "touchend":
                window.trendDrawer.reRender();
                break;
            case "touchmove":
                event.preventDefault();
                window.trendDrawer.drawReticle(event.touches[0].clientX, event.touches[0].clientY);
                break;
        }
    }
}

/**
 * 动画显示资产配置饼图数据
 */
function animatePie() {
    var existStatus = [isAssetNotExist(), isIndustryNotExist(), isBondTypeNotExist(), isCountryNotExist()];
    var index = findFirstTab(existStatus);
    var indexValue = "asset";
    switch (index) {
        case 0:
            indexValue = "asset";
            break;
        case 1:
            indexValue = "industry";
            break;
        case 2:
            indexValue = "bondType";
            break;
        case 3:
            indexValue = "country";
            break;
    }
    var pieData = prepareAssetPieData(indexValue);
    if (undefined != window.myPie) {
        window.myPie.draw(pieData, fixString(Session.productArchive.fundScale));
    } else {
        window.myPie = new AssetsPieDrawer("assets");
        window.myPie.draw(pieData, fixString(Session.productArchive.fundScale));
    }
    myScroll.refresh();
}

function prepareAssetPieData(tag) {
    var pieData = new Array();
    switch (tag) {
        case 'asset':
        {
            var valueS = [];
            if (Session.assetsConfigInfo && Session.assetsConfigInfo.assetAllocation &&
                Session.assetsConfigInfo.assetAllocation.items && Session.assetsConfigInfo.assetAllocation.items.length > 0) {
                $.each(Session.assetsConfigInfo.assetAllocation.items, function (index, el) {
                    if (!isNaN(el.navRate)) {
                        pieData.push({
                            value: parseFloat(el.navRate),
                            subTxt: el.assetAllocationName
                        })
                    }
                });
            }
            break;
        }
        case 'industry':
        {
            var list = Session.assetsConfigInfo.industryInfo;
            $.each(list, function (index, el) {
                if (!isNaN(el.industryValueToNav)) {
                    pieData.push({
                        value: parseFloat(el.industryValueToNav),
                        subTxt: el.industryName
                    })
                }
            });
            break;
        }
        case 'bondType':
        {
            var valueS = [];
            if (Session.assetsConfigInfo && Session.assetsConfigInfo.bondTypeInfo &&
                Session.assetsConfigInfo.bondTypeInfo.length > 0) {
                $.each(Session.assetsConfigInfo.bondTypeInfo, function (index, el) {
                    if (!isNaN(el.navRate)) {
                        pieData.push({
                            value: parseFloat(el.navRate),
                            subTxt: el.bondTypeName
                        })
                    }
                });
            }
            break;
        }
        case 'country':
        {
            var list = Session.assetsConfigInfo.countryInfo;
            $.each(list, function (index, el) {
                if (!isNaN(el.ratio)) {
                    pieData.push({
                        value: parseFloat(el.ratio),
                        subTxt: el.country,
                    })
                }
            });
            break;
        }
    }

    //var sortedPieData = quickSort(pieData);
    //配色
    $.each(pieData, function (index, el) {
        el.color = COLOR_LIST[index];
    });
    return pieData;
}

var quickSort = function (arr) {
    if (arr.length <= 1) {
        return arr;
    }

    var pivotIndex = Math.floor(arr.length / 2);
    var temp = arr.splice(pivotIndex, 1)[0];

    var pivot = temp.value;
    var color = temp.color;
    var subTxt = temp.subTxt;

    var left = [];
    var right = [];
    for (var i = 0; i < arr.length; i++) {
        if (arr[i].value > pivot) {
            left.push(arr[i]);
        } else {
            right.push(arr[i]);
        }
    }
    return quickSort(left).concat({value: pivot, color: color, subTxt: subTxt}, quickSort(right));
};


/**
 * 绑定资产配置Tab点击切换
 */
function bindAssetTabClick() {
    $("#assets_tabs li").click(function () {
        $("#assets_tabs li a").removeClass("active");
        $(this).find("a").addClass("active");
        var tag = $(this).attr('tag');
        var pieData = prepareAssetPieData(tag);

        //资产配置维度切换功能点统计
        submitFunction("922400050025");

        if (undefined != window.myPie) {
            window.myPie.clear();
            window.myPie.draw(pieData, fixString(Session.productArchive.fundScale));
        } else {
            window.myPie = new AssetsPieDrawer("assets");
            window.myPie.draw(pieData, fixString(Session.productArchive.fundScale));
        }
        myScroll.refresh();
    });
}

/**
 * 绑定非货基金走势图Tab点击切换
 */
function bindTrendTabClick() {
    $("#fund_trend_tabs li").click(function () {
        $("#fund_trend_tabs li a").removeClass("active");
        $(this).find("a").addClass("active");
        var tag = $(this).attr('tag');
        $('#hide_trend_tag').val(tag);

        //功能点统计
        submitFunction("922400050019");

        //进度条
        showTrendLoading();

        if (localStorage) {
            var time = localStorage.getItem(window.windCode + CMD_CODE[2] + tag + "time");
            //三分钟缓存时间
            if (time && ((new Date().getTime() - time) / 1000 > (3 * 60))) {
                sendAjaxRequest(CMD_CODE[2], tag)
            } else {
                QueryHelper(window.windCode, CMD_CODE[2] + tag, function (value) {
                    if (undefined == value) {
                        sendAjaxRequest(CMD_CODE[2], tag)
                    } else {
                        var parsedObj = parserObject(value.data.messageBody);
                        if (parsedObj && parsedObj.dataList && parsedObj.dataList.length > 0) {
                            loadTrend(parsedObj, tag);
                        } else {
                            sendAjaxRequest(CMD_CODE[2], tag)
                        }
                    }
                });
            }
        }
    });
}

/**
 * 绑定货基走势图Tab点击切换
 */
function bindCurrencyTrendTabClick() {
    $("#cur_fund_trend_tabs li").click(function () {
        $("#cur_fund_trend_tabs li a").removeClass("active");
        $(this).find("a").addClass("active");
        var tag = $(this).attr('tag');
        $('#hide_trend_tag').val(tag);

        //加载进度条
        showTrendLoading();

        if (tag == "01") {
            showCurFundTrend();
        } else if (tag === "04") {
            if (undefined != window.scaleDrawer) {
                window.scaleDrawer.clear();
            }
            sendAjaxRequest(CMD_CODE[2], tag)
        }
        //功能点统计
        submitFunction("922400050020");
    });
}

function loadError(reqStatus, cmdCode, type) {
    if (!isShown()) {
        $("#loading_lay").fadeOut();
        $("#loadStatus_lay").fadeIn();
    }
    if (CMD_CODE[1] == cmdCode) {
        QueryHelper(window.windCode, CMD_CODE[1], function (value) {
            if (undefined != value) {
                var parsedObj = parserObject(value.data.messageBody);
                loadExtraPage(parsedObj);
            } else {
                $("#content_lay2").show().attr("showing", false);
                pullUpEl.className = '';
                $(".pullUpIcon").css("display", "");
                $(".pullUpLabel").html("加载失败，请稍候重试");
                myScroll.refresh();
                myScroll.isLoading = false;
            }
        });
    }
}

function isAssetNotExist() {
    if (!Session.assetsConfigInfo) {
        return true;
    }
    return !(Session.assetsConfigInfo && Session.assetsConfigInfo.assetAllocation && Session.assetsConfigInfo.assetAllocation.items &&
    Session.assetsConfigInfo.assetAllocation.items.length > 0);
}


function isIndustryNotExist() {
    try {
        if (!Session.assetsConfigInfo) {
            return true;
        }
        if (Session.assetsConfigInfo.industryInfo) {
            var list = Session.assetsConfigInfo.industryInfo;
            var flag = true;
            for (var i = 0; i < list.length; ++i) {
                if (!isNaN(list[i].industryValueToNav)) {
                    flag = false;
                    break;
                }
            }
            return flag;
        } else {
            return true;
        }
    } catch (e) {
    }
}
function isBondTypeNotExist() {
    if (!Session.assetsConfigInfo) {
        return true;
    }
    return !(Session.assetsConfigInfo && Session.assetsConfigInfo.bondTypeInfo && Session.assetsConfigInfo.bondTypeInfo.length > 0);
}

function isCountryNotExist() {
    if (!Session.assetsConfigInfo || !Session.assetsConfigInfo.countryInfo) {
        return true;
    }
    var list = Session.assetsConfigInfo.countryInfo;
    var flag = true;
    for (var i = 0; i < list.length; ++i) {
        if (!isNaN(list[i].ratio)) {
            flag = false;
            break;
        }
    }
    return flag;
}

function prepareTrendTopInfo(type) {
    var element = undefined;
    if (!Session.sectionShow || Session.sectionShow.length <= 0) {
        return element;
    }
    var compareName = "";
    switch (type) {
        case "01":
            compareName = "近一月";
            break;
        case "03":
            compareName = "近六月";
            break;
        case "04":
            compareName = "近一年";
            break;
        case "06":
            compareName = "成立至今";
            break;
    }

    for (var i = 0; i < Session.sectionShow.length; ++i) {
        var el = Session.sectionShow[i];
        if (el && el.clomnName == compareName) {
            element = {Nav: el.seflFund, SimFundAvgReturn: el.sameFund, Hs300AvgReturn: el.hs300};
            break;
        }
    }
    return element;
}

/**
 * 显示非货基加载进度
 */
function showTrendLoading() {
    $("#fund_trend_loading").show();
    $("#cur_fund_trend_loading").show();
}

/**
 * 隐藏非货基加载进度
 */
function hideTrendLoading() {
    $("#fund_trend_loading").hide();
    $("#cur_fund_trend_loading").hide();
}

function tryLoadAgain() {
    loading();
    loadCache();
    ajaxRequest();
}
