/**
 * Created by hyu.Yale on 2015/11/13.
 */
/**
 * 数据请求总入口
 */
function ajaxRequest() {
    sendAjaxRequest(CMD_CODE[0]);
    sendAjaxRequest(CMD_CODE[2], "NULL");
}

function sendAjaxRequest(cmdCode, type) {
    $.ajax({
        async: true,
        cache: false,
        //180.96.8.93测试站
        //10.100.5.171:8083
        //url: "http://10.102.16.66:8083/jfire/app/appRequest.do?",
        //url: "http://180.96.8.93:8083/jfire/app/appRequest.do?",
        url: "http://licai.wind.com.cn:8083/jfire/app/appRequest.do?",
        type: "GET",
        dataType: 'jsonp',
        data: buildRequestBody(cmdCode, type),
        timeout: 5000,
        success: function (comData) {
            onAjaxSuccess(cmdCode, type, comData)
        },
        error: function (jqXHR, textStatus, errorThrown) {
            onAjaxError(cmdCode, type, textStatus, errorThrown);
        },
    });
}

function buildRequestBody(cmdCode, type) {
    switch (cmdCode) {
        case CMD_CODE[0]:
        case CMD_CODE[1]:
        case CMD_CODE[3]:
            return "requestBody=" + buildBaseParams(cmdCode);
        case CMD_CODE[2]:
            return "requestBody=" + buildTrendParams(cmdCode, type);
    }
}

function buildBaseParams(cmdCode) {
    var reqStr =
        '{"appId":"' + Session.default.appId + '",' +
        '"appType":"' + Session.default.appType + '",' +
        '"appVersion":"' + Session.default.appVersion + '",' +
        '"channelCode":0,' +
        '"cmdCode":"' + cmdCode + '",' +
        '"mobilePlatform":"' + Session.default.mobilePlatform + '",' +
        '"parameters":{\"windCode\": \"' + window.windCode + '\"},' +
        '"sessionId":"' + Session.default.sessionId + '"}';
    return reqStr;
}

function buildTrendParams(cmdCode, type) {
    var params = '"parameters":{\"windCode\": \"' + window.windCode + '\",\"type\":\"' + type + '\"},';
    if ("NULL" == type || "null" == type) {
        params = '"parameters":{\"windCode\": \"' + window.windCode + '\"},';
    }
    var reqStr =
        '{"appId":"' + Session.default.appId + '",' +
        '"appType":"' + Session.default.appType + '",' +
        '"appVersion":"' + Session.default.appVersion + '",' +
        '"channelCode":0,' +
        '"cmdCode":"' + cmdCode + '",' +
        '"mobilePlatform":"' + Session.default.mobilePlatform + '",' +
        params +
        '"sessionId":"' + Session.default.sessionId + '"}';
    return reqStr;
}

function onAjaxSuccess(cmdCode, type, comData) {
    //loadingFinish();
    onDataHandled(cmdCode, type, comData);
}

function onAjaxError(cmdCode, type, textStatus, errorThrown) {
    switch (cmdCode) {
        case CMD_CODE[0]:
            loadError(textStatus, cmdCode, type);
        case CMD_CODE[1]:
            loadError(textStatus, cmdCode, type);
            break;
        case CMD_CODE[3]:
            loadError(textStatus, cmdCode, type);
            break;
    }
}

function onDataHandled(cmdCode, type, comData) {
    if (comData) {
        //请求成功的时候，解析数据结构
        if (comData.resultCode == SUCCESS) {
            var parsedObj = parserObject(comData.messageBody);
            //缓存数据
            if ("NULL" == type) {
                type = "01";
            }
            cacheStore(window.windCode, cmdCode, type, comData);
            dispatchHandledModel(cmdCode, type, parsedObj);
        } else {
            handleFailure(cmdCode, type);
        }
    }
}

function dispatchHandledModel(cmdCode, type, parsedObj) {
    //根据CMD请求解析数据并派发
    switch (cmdCode) {
        case CMD_CODE[0]:
            loadBasePage(parsedObj)
            break;
        case CMD_CODE[1]:
            loadExtraPage(parsedObj);
            break;
        case CMD_CODE[2]:
            loadTrend(parsedObj, type);
            break;
        case CMD_CODE[3]:
            loadManagerList(parsedObj);
            break;
    }
}

function handleFailure(cmdCode, type) {
    //根据CMD请求解析数据并派发
    switch (cmdCode) {
        case CMD_CODE[0]:
            loadBaseFailed();
            break;
        case CMD_CODE[1]:
            break;
        case CMD_CODE[2]:
            break;
        case CMD_CODE[3]:
            break;
    }
}
