/**
 * Created by hyu.Yale on 2015/11/3.
 */

STATUS = ["up", "common", "down"];

function StringBuffer() {
    this.str = new Array();
}
StringBuffer.prototype.append = function (str) {
    this.str.push(str);
}
StringBuffer.prototype.toString = function () {
    return this.str.join('');
}
StringBuffer.prototype.getLength = function () {
    return this.str.join('').length;
}

StringBuffer.prototype.isEmpty = function () {
    return this.str.join('').length == 0;
}

function getObjectKeys(object) {
    var keys = [];
    for (var property in object)
        keys.push(property);
    return keys;
}

function getObjectValues(object) {
    var values = [];
    for (var property in object)
        values.push(object[property]);
    return values;
}

function GetQueryString(name) {
    var reg = new RegExp("(^|&)" + name + "=([^&]*)(&|$)");
    var r = window.location.search.substr(1).match(reg);
    if (r != null)return unescape(r[2]);
    return null;
}

function fixNum(originalValue, count, forse) {
    if (isNaN(originalValue)) {
        return originalValue;
    } else {
        if (0 == originalValue) {
            if (forse) {
                return parseFloat(originalValue).toFixed(count);
            } else {
                return 0;
            }
        }
        return parseFloat(originalValue).toFixed(count)
    }
}

function parserObject(messageBody) {
    return JSON.parse(messageBody, function (key, value) {
        var type;
        if (value && typeof value === 'object') {
            type = value.type;
            if (typeof type === 'string' && typeof window[type] === 'function') {
                return new (window[type])(value);
            }
        }
        return value;
    });
}

function isSupportIndexedDB() {
    return window.indexedDB || window.mozIndexedDB || window.webkitIndexedDB || window.msIndexedDB;
}

//function isSupportIndexedDB() {
//    return false;
//}

function isSupportLocalStorage() {
    return window.localStorage;
}


function isEmpty(value) {
    return (value == undefined || value === "");
}

function formatNavDate(value) {
    if (value) {
        var arrays = value.split("-");
        if (arrays && arrays.length > 2) {
            return arrays[1] + "/" + arrays[2];
        }
    }
    return value;
}

function subFixedString(value, count) {
    if (value.length > count) {
        return value.substr(count, value.length);
    }
    return value;
}

function subFixedStringFromStart(value, count) {
    if (value.length > count) {
        return value.substr(0, count);
    }
    return value;
}


function fixString(value) {
    if (undefined == value || isEmpty(value)) {
        return "--";
    } else {
        return value;
    }
}

function fixStringRate(value) {
    if (undefined == value || isEmpty(value)) {
        return "--";
    } else {
        if (isNaN(value)) {
            return value;
        } else {
            return value + "%";
        }
    }
}

function checkUpOrDown(value) {
    if (isEmpty(value)) {
        return STATUS[1];
    } else {
        if (isNaN(value)) {
            return STATUS[1];
        } else {
            if (value > 0) {
                return STATUS[0];
            } else if (value == 0) {
                return STATUS[1];
            } else {
                return STATUS[2];
            }
        }
    }
}

function findMaxTxt(maxWidth, strTxt, context) {
    var index = strTxt.length;
    var tempTxt = strTxt;
    while (context.measureText(tempTxt).width > maxWidth) {
        tempTxt = strTxt.substr(0, index);
        index--;
    }
    return tempTxt;
}

function formatManagerYear(years) {
    if (undefined == years || isNaN(years)) {
        return fixString(years)
    }
    return parseInt(years);
}

