/**
 * Created by hyu.Yale on 2015/10/26.
 */

function AssetsPieDrawer(el) {
    if (undefined == this.canvas) {
        this.canvas = document.getElementById(el);
    }
    if (!this.canvas) {
        return;
    }
    this.ctx = this.canvas.getContext("2d");
    this.mWidth = this.canvas.width;
    this.mHeight = this.canvas.height;

    this.mCenterX = this.canvas.width / 2;
    this.mDiameter = this.mModelDiameter * this.canvas.width / this.mModelBodyWidth;
    this.mSingleGap = this.mModelSingleGap * this.canvas.width / this.mModelBodyWidth;
    this.mRingWidth = this.mModelRingWidth * this.canvas.width / this.mModelBodyWidth;

    this.mCenterX = this.canvas.width / 2
    this.mCenterY = this.mSingleGap + this.mDiameter / 2;


    var ctx = this.ctx,
        width = this.mWidth,
        height = this.mHeight;

    if (window.devicePixelRatio) {
        this.canvas.style.width = width + "px";
        this.canvas.style.height = height + "px";
        this.canvas.height = height * window.devicePixelRatio;
        this.canvas.width = width * window.devicePixelRatio;
        ctx.scale(window.devicePixelRatio, window.devicePixelRatio);
    }
}

AssetsPieDrawer.prototype = {
    mWidth: 0,//Canvas宽度
    mHeight: 0,//Canvas 高度
    mCenterX: 0,//圆心X
    mCenterY: 0,//圆心Y
    mSingleGap: 0,//上下间距
    mDiameter: 0,//圆直径
    mRingWidth: 0,//环宽度
    mBodyWidth: 0,//饼图主体内容宽度
    mBodyHeight: 0,//饼图主体内容宽度
    mDataSourceCount: 3,//饼图主体内容宽度
    mScreenWidth: 320,//基于屏幕760宽度做的图

    mModelSingleGap: 30,//效果图上下间距
    mModelDiameter: 312,//效果图圆直径
    mModelRingWidth: 60,//效果图环宽度
    mModelBodyWidth: 688,//效果图饼图主体内容宽度
    mModelBodyHeight: 462,//效果图饼图主体内容宽度
    mModelScreenWidth: 760,//效果图基于屏幕760宽度做的图
    version: "1.0.1",
    color: "#DFDFDF",
    drawArc: function () {
        this.ctx.fillStyle = "red";
        this.ctx.beginPath();
        this.ctx.arc(this.mCenterX, this.mCenterY, this.mDiameter / 2 - this.mRingWidth / 2 - 2, Math.PI / 2, 2 * Math.PI * 0.85, false);
        this.ctx.lineWidth = this.mRingWidth;
        this.ctx.strokeStyle = "#fec74b";
        this.ctx.stroke();

        this.ctx.beginPath();
        this.ctx.arc(this.mCenterX, this.mCenterY, this.mDiameter / 2, Math.PI / 2, 2 * Math.PI * 0.85, false);
        this.ctx.lineWidth = 1;
        this.ctx.stroke();


        this.ctx.beginPath();
        this.ctx.arc(this.mCenterX, this.mCenterY, this.mDiameter / 2 - this.mRingWidth / 2 - 2, 2 * Math.PI * 0.85, 0, false);
        this.ctx.lineWidth = this.mRingWidth;
        this.ctx.strokeStyle = "#fe949b";
        this.ctx.stroke();

        this.ctx.beginPath();
        this.ctx.arc(this.mCenterX, this.mCenterY, this.mDiameter / 2, 2 * Math.PI * 0.85, 0, false);
        this.ctx.lineWidth = 1;
        this.ctx.stroke();

        this.ctx.beginPath();
        this.ctx.arc(this.mCenterX, this.mCenterY, this.mDiameter / 2 - this.mRingWidth / 2 - 2, 0, Math.PI / 2, false);
        this.ctx.lineWidth = this.mRingWidth;
        this.ctx.strokeStyle = "#80adf7";
        this.ctx.stroke();

        this.ctx.beginPath();
        this.ctx.arc(this.mCenterX, this.mCenterY, this.mDiameter / 2, 0, Math.PI / 2, false);
        this.ctx.lineWidth = 1;
        this.ctx.stroke();
    },

    drawSubTxt: function () {
        var gap = 50;//单行文字的前后间距
        var rectWidth = 10;//矩形宽度
        var rectTxtMargin = 10;//文字距离矩形的间距

        var text1 = "股票（65%）";
        var text2 = "基金（10%）";
        var text3 = "债券（25%）";

        var measureObj1 = this.ctx.measureText(text1);
        var measureObj2 = this.ctx.measureText(text2);

        var leftRightMargin = (this.mWidth - measureObj1.width - measureObj2.width - gap - 2 * (rectWidth + rectTxtMargin)) / 2
        var startX = leftRightMargin;
        var startY = 2 * this.mSingleGap + this.mDiameter;

        this.ctx.fillStyle = "#fec74b"
        this.ctx.fillRect(startX, startY - rectWidth + 2, rectWidth, rectWidth);
        this.ctx.fillText(text1, startX + rectWidth + rectTxtMargin, startY);


        startX = leftRightMargin + rectWidth + rectTxtMargin + measureObj1.width + gap;
        this.ctx.fillStyle = "#fe949b";
        this.ctx.fillRect(startX, startY - rectWidth + 2, rectWidth, rectWidth);
        this.ctx.fillText(text2, startX + rectWidth + rectTxtMargin, startY);


        startX = leftRightMargin;
        startY = 4 * this.mSingleGap + this.mDiameter;
        this.ctx.fillStyle = "#80adf7";
        this.ctx.fillRect(startX, startY - rectWidth + 2, rectWidth, rectWidth);
        this.ctx.fillText(text3, startX + rectWidth + rectTxtMargin, startY);
    },

    drawCenterTxt: function () {
        var txt = "总资产";
        var money = "36.82元";
        var txtVerticalMargin = 10;
        var measuredObj1 = this.ctx.measureText(txt);
        var measuredObj2 = this.ctx.measureText(money);

        this.ctx.fillStyle = "#666";
        var startX = this.mCenterX - measuredObj1.width / 2;
        var startY = this.mCenterY - txtVerticalMargin / 2;
        this.ctx.fillText(txt, startX, startY);

        startX = this.mCenterX - measuredObj2.width / 2;
        startY = this.mCenterY + txtVerticalMargin;
        this.ctx.fillText(money, startX, startY);
    },

    draw: function () {
        this.drawArc();
        this.drawSubTxt();
        this.drawCenterTxt();
    }
}