/**
 * Created by hyu.Yale on 2015/10/29.
 */

var myScroll,
    pullDownEl, pullDownOffset,
    pullUpEl, pullUpOffset,
    generatedCount = 0;

/**
 * 下拉刷新 （自定义实现此方法）
 * myScroll.refresh();        // 数据加载完成后，调用界面更新方法
 */
function pullDownAction() {
    setTimeout(function () {
        myScroll.refresh();
    }, 2000);
}

/**
 * 滚动翻页 （自定义实现此方法）
 * myScroll.refresh();        // 数据加载完成后，调用界面更新方法
 */
function pullUpAction() {
    //第二页已经显示则无需在执行
    if ($("#content_lay2").attr("showing")) {
        return;
    }
    reqExtraAttr();
}

/**
 * 初始化iScroll控件
 */
function loaded() {
    pullDownEl = document.getElementById('pullDown');
    pullDownOffset = pullDownEl.offsetHeight;
    pullUpEl = document.getElementById('pullUp');
    pullUpOffset = pullUpEl.offsetHeight;

    myScroll = new iScroll('wrapper', {
        scrollbarClass: 'myScrollbar', /* 重要样式 */
        useTransition: false, /* 此属性不知用意，本人从true改为false */
        topOffset: pullDownOffset,
        onRefresh: function () {
            if (this.isLoading) {
                return;
            }
            if (pullDownEl.className.match('loading')) {
                pullDownEl.className = '';
                $(".pullDownLabel").html("下拉刷新...");
            } else if (pullUpEl.className.match('loading')) {
                pullUpEl.className = '';
                $(".pullUpLabel").html("上拉加载更多...");
            }
        },
        onScrollMove: function () {
            if (this.isLoading) {
                return;
            }
            if (this.y > 5 && !pullDownEl.className.match('flip')) {
                pullDownEl.className = 'flip';
                this.minScrollY = 0;
                $(".pullDownLabel").html("松手开始更新...");
            } else if (this.y < 5 && pullDownEl.className.match('flip')) {
                pullDownEl.className = '';
                this.minScrollY = -pullDownOffset;
                $(".pullDownLabel").html("下拉刷新...");
            } else if (this.y < (this.maxScrollY - 5) && !pullUpEl.className.match('flip')) {
                pullUpEl.className = 'flip';
                this.maxScrollY = this.maxScrollY;
                $(".pullUpLabel").html("松手开始更新...");
            } else if (this.y > (this.maxScrollY + 5) && pullUpEl.className.match('flip')) {
                pullUpEl.className = '';
                this.maxScrollY = pullUpOffset;
                $(".pullUpLabel").html("上拉加载更多...");
            }
        },
        onScrollEnd: function () {
            if (this.isLoading) {
                return;
            }
            if (pullDownEl.className.match('flip')) {
                pullDownEl.className = 'loading';
                myScroll.isLoading = true;
                $(".pullDownLabel").html("加载中...");
                pullDownAction();
            } else if (pullUpEl.className.match('flip')) {
                pullUpEl.className = 'loading';
                $(".pullUpIcon").css("display", "block");
                myScroll.isLoading = true;
                $(".pullUpLabel").html("加载中...");
                pullUpAction();
            }
        }
    });
}

//初始化绑定iScroll控件
$(document).ready(function () {
    bindAssetTabClick();
    $("#content_lay2").hide();
    //var scaleDrawer = new ScaleDrawer("fund_scale");
    //scaleDrawer.draw();
    document.addEventListener('touchmove', function (e) {
        e.preventDefault();
    }, false);
    loaded();

    if(isSupportIndexedDB()){
        $.indexedDB(DB_CONFIG.dbName, {
            "schema": {
                "1": function (versionTransaction) {
                    var catalog = versionTransaction.createObjectStore(DB_CONFIG.tableName, {
                        "keyPath": "windCode"
                    });
                    catalog.createIndex("windCode");
                }
                // This was added in the next version of the site
                //"2": function (versionTransaction) {
                //    var cart = versionTransaction.createObjectStore("cart", {
                //        "autoIncrement": true
                //    });
                //    cart.createIndex("itemId");
                //    cart.createIndex("youxi");
                //    var wishlist = versionTransaction.createObjectStore("wishlist", {
                //        "autoIncrement": false,
                //        "keyPath": "itemId"
                //    });
                //    wishlist.createIndex("name");
                //}
            }
        });
    }
    loadPage("000001.OF");
});










