/**
 * Created by hyu.Yale on 2015/11/13.
 */
/**
 * 根据WindCode加载页面数据
 * @param windCode 基金的WindCode
 */
function loadPage(windCode) {
    if (window.windCode == undefined || window.windCode != windCode) {
        window.windCode = windCode;
    }
    loading();
    loadCache();
    ajaxRequest();
}

function loading() {
    $("#loading_lay").show();
}
function loadingFinish() {
    $("#loading_lay").fadeOut(500);
}

Session.isCurrencyFund = function (type) {
    return type == '01';
}

Session.fundType = function () {
    return Session.topInfo.fundType;
}


/**
 * 加载基金缓存
 */
function loadCache() {
    try {
        QueryHelper(window.windCode, CMD_CODE[0], function (value) {
            if (undefined != value) {
                var parsedObj = parserObject(value.data.messageBody);
                loadBasePage(parsedObj);
            }
        });

        QueryHelper(window.windCode, CMD_CODE[2] + "01", function (value) {
            if (undefined != value) {
                var parsedObj = parserObject(value.data.messageBody);
                loadTrend(parsedObj, "01");
            }
        });
    } catch (e) {
    }
}


/**
 * 客户端准备分享参数
 */
function onShare() {
    try {
        var params = {type: 209, data: {windName: Session.topInfo.windName, shareInfo: Session.shareInfo}};
        shell_Req(JSON.stringify(params))
    } catch (e) {
    }
}


/**
 * 加载基础页面
 * @param parsedObj 解析过的数据项
 */
function loadBasePage(parsedObj) {
    loadingFinish();

    $("#hide_showing").val(true);

    Session.topInfo = parsedObj.topInfo;
    Session.operationInfo = parsedObj.operationInfo;
    Session.productArchive = parsedObj.productArchive;
    Session.rating = parsedObj.productArchive;
    Session.sectionShow = parsedObj.sectionShow;
    Session.shareInfo = parsedObj.shareInfo;


    //告知客户端存储分享的数据，仅仅是存储
    onShare();

    //顶部信息
    createTopLay();
    showTopInfo();

    //广告栏位
    if (Session.operationInfo && Session.operationInfo.operationDesc) {
        createBannerLay();
        showBanner();
    }

    if (Session.isCurrencyFund(Session.topInfo.fundType)) {
        Session.areaChart = parsedObj.areaChart;
        createCurrencyTrendCanvas();
        showCurFundTrend();
    } else {
        createTrendCanvas();
    }

    //阶段表现
    createStageLay();
    showFundStage();

    //产品档案
    createProductDocLay()
    showFundDoc();


    $(".pullUpLabel").html("继续拖动，查看产品详情");
}

/**
 * 加载额外信息页面（第二页）
 * @param parsedObj 解析过的数据项
 */
function loadExtraPage(parsedObj) {
    Session.assetsConfigInfo.assetAllocation = parsedObj.assetsConfigInfo.assetAllocation;
    Session.assetsConfigInfo.industryInfo = parsedObj.assetsConfigInfo.industryInfo;
    Session.assetsConfigInfo.bondTypeInfo = parsedObj.assetsConfigInfo.bondTypeInfo;
    Session.assetsConfigInfo.countryInfo = parsedObj.assetsConfigInfo.countryInfo;

    Session.companyInfo = parsedObj.companyInfo;
    Session.fundScaleList = parsedObj.fundScaleList;
    Session.managerInfo = parsedObj.managerInfo;
    Session.holdingStock = parsedObj.holdingStock;
    Session.bankList = parsedObj.bankList;

    //测试数据
    //Session.fundScaleList = [{
    //    "FundScale": "5.35",
    //    "PurchaseRedeemNetAccount": "",
    //    "QuarterName": "14Q3",
    //    "WindCode": "400022.OF"
    //},{
    //    "FundScale": "14.35",
    //    "PurchaseRedeemNetAccount": "",
    //    "QuarterName": "11Q3",
    //    "WindCode": "400032.OF"
    //}]

    //规模变化,一条数据不显示
    if (Session.fundScaleList && Session.fundScaleList.length > 1) {
        createScaleLay();
        showScaleInfo();
    }

    //资产配置
    createAssetPieLay();

    //重仓持股
    if (Session.holdingStock && Session.holdingStock.length > 0) {
        createHoldingStockLay();
        showHoldStockList();
    }

    //基金经理
    createAndShowManager(parsedObj.managerInfo);

    //基金公司
    createManagerCompanyLay();
    showCompanyInfo();

    //支持的银行
    showBankList(Session.bankList);
    animateNextPage();
}


/**
 * 动画展现第二页数据
 */
function animateNextPage() {
    $("#content_lay2").show().attr("showing", true);
    $("#pullUp").hide();
    myScroll.refresh();
    myScroll.scrollToElement(document.getElementById("content_lay2"));
    animatePie();
}

function showTopInfo() {
    var fundAttr = {
        "flag": {type: "", risk: "", purLimit: "", save: ""},
        "attr": [{key: "", value: ""}, {key: "", value: ""}, {key: "", value: ""}]
    };
    fundAttr.type = fixString(Session.topInfo.firstInvestType);
    fundAttr.risk = fixString(Session.topInfo.riskAttribute);
    fundAttr.purLimit = fixString(Session.topInfo.purchaseLimitMinDesc);
    fundAttr.save = fixString(Session.topInfo.redeemToAccDesc);

    if (Session.isCurrencyFund(Session.topInfo.fundType)) {
        fundAttr.attr[0].key = "万份收益";
        fundAttr.attr[0].value = fixNum(Session.topInfo.mmfUnitYield, 2);

        fundAttr.attr[1].key = "七日年化";
        fundAttr.attr[1].value = fixStringRate(Session.topInfo.mmfAnnualizedYield);

        fundAttr.attr[2].key = "净值日期";
        fundAttr.attr[2].value = fixString(subFixedString(Session.topInfo.navDate, 5));
    } else {
        fundAttr.attr[0].key = "最新净值";
        fundAttr.attr[0].value = fixNum(Session.topInfo.navUnit, 2);

        fundAttr.attr[1].key = "日涨幅";
        fundAttr.attr[1].value = fixStringRate(Session.topInfo.navIncrease);

        fundAttr.attr[2].key = "净值日期";
        fundAttr.attr[2].value = fixString(subFixedString(Session.topInfo.navDate, 5));
    }

    $("#top_list_first_key").html(fundAttr.attr[0].key);
    $("#top_list_first_value").html(fixStringRate(fundAttr.attr[0].value));

    $("#top_list_second_key").html(fundAttr.attr[1].key);
    if (fundAttr.attr[1].value > 0) {
        $("#top_list_second_value").addClass("red-color").html(fixNum(fundAttr.attr[1].value, 2));
    } else {
        $("#top_list_second_value").addClass("green-color").html(fixNum(fundAttr.attr[1].value, 2));
    }

    $("#top_list_third_key").html(fundAttr.attr[2].key);
    $("#top_list_third_value").html(fundAttr.attr[2].value);

    $("#fund_top_type").html(fundAttr.type);
    $("#fund_top_risk").html(fundAttr.risk);
    $("#fund_top_limit").html(fundAttr.purLimit);
    $("#fund_top_save").html(fundAttr.save);
}
function showBanner() {
    $("#banner").html(Session.operationInfo.operationDesc);
}

function showFundStage() {
    var buffer = new StringBuffer();
    $.each(Session.sectionShow, function (index, el) {
        //标题头
        if (index == 0) {
            buffer.append("<ul class='fund-stage-title'>");
        } else {
            buffer.append("<ul class='fund-stage-data-ul'>");
        }
        buffer.append("<li>" + fixString(el.clomnName) + "</li>")

        var status = checkUpOrDown(el.seflFund);
        if (status == STATUS[0]) {
            buffer.append("<li class='second-child red-color'>" + fixStringRate(el.seflFund) + "</li>")
        } else if (status == STATUS[2]) {
            buffer.append("<li class='second-child green-color'>" + fixStringRate(el.seflFund) + "</li>")
        } else {
            buffer.append("<li class='second-child'>" + fixStringRate(el.seflFund) + "</li>")
        }

        if ("" == el.ranking.trim()) {
            el.ranking = "--";
        }
        if (index == 0) {
            buffer.append("<li id='sortColumn'>" + fixString(el.sameFund) + "</li>")
            buffer.append("<li id='sortId' tag='same' onclick='changeSimalarHs300()'><img class='ranking-sort' src='./style/images/arrow_down_small.png'/>" + el.ranking + "</li>")
        } else {
            var status = checkUpOrDown(el.sameFund);
            if (status == STATUS[0]) {
                buffer.append("<li class='canSorted red-color' tag='column" + index + "'>" + fixStringRate(el.sameFund) + "</li>");
            } else if (status == STATUS[2]) {
                buffer.append("<li class='canSorted green-color' tag='column" + index + "'>" + fixStringRate(el.sameFund) + "</li>");
            } else {
                buffer.append("<li class='canSorted' tag='column" + index + "'>" + fixStringRate(el.sameFund) + "</li>");
            }
            buffer.append("<li>" + fixString(el.ranking) + "</li>");
        }
        buffer.append("</ul>");
    });
    $("#fund_stage").html(buffer.toString());
}

function changeSimalarHs300() {
    try {
        var tag = $("#sortId").attr("tag");
        if ("same" == tag) {
            $.each($(".canSorted"), function (index, el) {
                var showValue = Session.sectionShow[index + 1].hs300;
                var status = checkUpOrDown(showValue);
                if (status == STATUS[0]) {
                    $(el).removeClass("green-color").addClass("red-color");
                } else if (status == STATUS[2]) {
                    $(el).removeClass("red-color").addClass("green-color");
                } else {
                    $(el).removeClass("red-color").removeClass("green-color");
                }
                $(el).html(fixStringRate(showValue));
            })
            $("#sortId").attr("tag", "hs300");
            $("#sortId img").addClass("rotate");
            $("#sortColumn").html(fixString(Session.sectionShow[0].hs300));
        } else if ("hs300" == tag) {
            $.each($(".canSorted"), function (index, el) {
                var showValue = Session.sectionShow[index + 1].sameFund;
                var status = checkUpOrDown(showValue);
                if (status == STATUS[0]) {
                    $(el).removeClass("green-color").addClass("red-color");
                } else if (status == STATUS[2]) {
                    $(el).removeClass("red-color").addClass("green-color");
                } else {
                    $(el).removeClass("red-color").removeClass("green-color");
                }
                $(el).html(fixStringRate(showValue));
            })
            $("#sortId").attr("tag", "same");
            $("#sortId img").removeClass("rotate");
            $("#sortColumn").html(fixString(Session.sectionShow[0].sameFund));
        }
    } catch (e) {
        console.log("index is out of range");
    }
}


function showFundDoc() {
    $("#corpName").html(fixString(Session.productArchive.corpName));
    $("#fundManagerName").html(fixString(Session.productArchive.fundManagerName));
    $("#fundScale").html(fixString(Session.productArchive.fundScale));
    $("#purchaseFeeRate").html(fixString(Session.productArchive.purchaseFeeRate));
    $("#redeemFeeRate").html(fixString(Session.productArchive.redeemFeeRate));

    if (isEmpty()) {
        $("#channelFeeRate").html(fixString(Session.productArchive.channelFeeRate));
    } else {
        if (Session.productArchive.channelFeeRate == 1) {
            $("#channelFeeRate").html("无折扣");
        } else {
            $("#channelFeeRate").html(10 * Session.productArchive.channelFeeRate + "折");
        }
    }
    $("#setupDate").html(fixString(Session.productArchive.setupDate));
    $("#realPurchaseFeeRate").html(fixString(Session.productArchive.realPurchaseFeeRate));
}

function showCompanyInfo() {
    //基金公司全称
    $("#fund_company_name").html(fixString(Session.companyInfo.CorpName));
    //旗下多少支基金
    $(".company-count").html(fixString(Session.companyInfo.FundNo));
    //成立日期
    $("#CorpSetupDate").html(fixString(Session.companyInfo.CorpSetupDate));
    //总规模
    $("#CorpScale").html(fixString(Session.companyInfo.CorpScale));
    //注册资本
    $("#RegisteredCapital").html(fixString(Session.companyInfo.RegisteredCapital));
    //总经理
    $("#CorpManager").html(fixString(Session.companyInfo.CorpManager));
    //旗下基金经理
    $("#FundManagersNo").html(fixString(Session.companyInfo.FundManagersNo));
    //基金经理平均年限
    $("#AverageWorkYear").html(fixString(fixNum(Session.companyInfo.AverageWorkYear, 2)));
}

function showScaleInfo() {
    var dataList = [];
    $.each(Session.fundScaleList, function (index, el) {
        dataList.push({
            txt: el.FundScale + "亿",
            barBottomTxt: el.QuarterName,
            value: el.FundScale
        });
    });

    if (window.fundScaleDrawer == undefined) {
        window.fundScaleDrawer = new ScaleDrawer("fund_scale");
    } else {
        window.fundScaleDrawer.clear()
    }
    window.fundScaleDrawer.draw(dataList)
}

function showHoldStockList() {
    var dataList = new Array();
    $.each(Session.holdingStock, function (index, el) {
        dataList.push({
            name: "" + el.stockName + "",
            rate: el.stockToMarket,
            rateTxt: parseFloat(el.latest3MonthBenifit).toFixed(2),
            up: el.latest3MonthBenifit >= 0 ? true : false
        });
    })

    window.assetsBarDrawer = new AssetsBarDrawer("assetBar");
    assetsBarDrawer.draw(dataList);
}

function showBankList(bankList) {
    createAndShowBankLay(bankList);
}

/**
 * 加载基础页面
 * @param parsedObj 解析过的数据项
 */
function loadTrend(parsedObj, type) {
    if (parsedObj && parsedObj.dataList && parsedObj.dataList.length > 0) {
        if (Session.isCurrencyFund(parsedObj.fundType) || parsedObj.dataList[0].MmfAnnualizedYield) {
            createCurrencyTrendCanvas();
            if (( $('#hide_trend_tag').val() == "04") && (window.scaleDrawer != undefined)) {
                loadTrendData(true, parsedObj.dataList, type);
            }
        } else {
            if (1 == $("#fund_trend").length) {
                loadTrendData(false, parsedObj.dataList, type);
            } else {
                createTrendCanvas();
                loadTrendData(false, parsedObj.dataList, type);
            }
        }
    }
}

/**
 * 加载非货币基金趋势图数据
 * @param parsedObj 非货基数据
 */
function loadTrendData(flag, parsedObj, type) {
    if (!flag) {
        Session.trendData = parsedObj;
        if (undefined != Session.trendData && Session.trendData.length > 0) {
            var minArr = [1000000, 1000000, 1000000];
            var maxArr = [-1000000, -1000000, -1000000];
            //找出最大最小值
            var parserValue;
            $.each(Session.trendData, function (index, el) {
                if (!isNaN(el.Nav)) {
                    parserValue = parseFloat(el.Nav);
                    if (parserValue > maxArr[0]) {
                        maxArr[0] = parserValue;
                    }
                    if (parserValue < minArr[0]) {
                        minArr[0] = parserValue;
                    }
                }
                if (!isNaN(el.SimFundAvgReturn)) {
                    parserValue = parseFloat(el.SimFundAvgReturn);
                    if (parserValue > maxArr[1]) {
                        maxArr[1] = parserValue;
                    }
                    if (parserValue < minArr[1]) {
                        minArr[1] = parserValue;
                    }
                }
                if (!isNaN(el.Hs300AvgReturn)) {
                    parserValue = parseFloat(el.Hs300AvgReturn);
                    if (parserValue > maxArr[2]) {
                        maxArr[2] = parserValue;
                    }
                    if (parserValue < minArr[2]) {
                        minArr[2] = parserValue;
                    }
                }
            });

            var maxValue = maxArr[0];
            var minValue = minArr[0];

            $.each(maxArr, function (index, el) {
                if (el > maxValue) {
                    maxValue = el
                }
            });
            $.each(minArr, function (index, el) {
                if (el < minValue) {
                    minValue = el
                }
            });

            if (undefined == window.trendDrawer) {
                window.trendDrawer = new TrendDrawer("trend", onDataBack);
            }
            trendDrawer.drawTrend(type, Session.trendData, maxValue, minValue, true);
            trendDrawer.canvas.addEventListener('touchstart', touchHandler, false);
            trendDrawer.canvas.addEventListener('touchmove', touchHandler, false);
            trendDrawer.canvas.addEventListener('touchend', touchHandler, false);
        }
    } else {
        if (undefined != parsedObj && parsedObj.length > 0) {
            var minArr = [1000000, 1000000];
            var maxArr = [-1000000, -1000000];
            //找出最大最小值
            var parserValue;
            $.each(parsedObj, function (index, el) {
                if (!isNaN(el.MmfAnnualizedYield)) {
                    parserValue = parseFloat(el.MmfAnnualizedYield);
                    if (parserValue > maxArr[0]) {
                        maxArr[0] = parserValue;
                    }
                    if (parserValue < minArr[0]) {
                        minArr[0] = parserValue;
                    }
                }
                if (!isNaN(el.MmfUnitYield)) {
                    parserValue = parseFloat(el.MmfUnitYield);
                    if (parserValue > maxArr[1]) {
                        maxArr[1] = parserValue;
                    }
                    if (parserValue < minArr[1]) {
                        minArr[1] = parserValue;
                    }
                }
            });
            scaleDrawer.drawTrend(parsedObj, maxArr, minArr)
        }
    }
}

/**
 * 显示货币基金走势图
 */
function showCurFundTrend() {
    if (Session.areaChart) {
        var dataList = [{
            txt: Session.areaChart.demandDeposit + "倍",
            barBottomTxt: "活期利率",
            value: Session.areaChart.demandDeposit
        },
            {txt: Session.areaChart.termDeposit + "倍", barBottomTxt: "定期", value: Session.areaChart.termDeposit},
            {
                txt: Session.areaChart.currFundDeposit + "倍",
                barBottomTxt: "本基金",
                value: Session.areaChart.currFundDeposit
            }];
        if (window.scaleDrawer == undefined) {
            window.scaleDrawer = new ScaleDrawer("cur_trend");
        } else {
            window.scaleDrawer.clear()
        }
        window.scaleDrawer.draw(dataList);
    }
}

function onDataBack(curFund, similarFund, hs300Fund) {
    //$("#curFund").html(curFund);
    //$("#similarFund").html(similarFund);
    //$("#hs300Fund").html(hs300Fund);
}

function touchHandler(event) {
    if ($('#hide_trend_tag').val() != trendDrawer.mType) {
        return;
    }
    if (trendDrawer) {
        var event = event || window.event;
        switch (event.type) {
            case "touchstart":
                break;
            case "touchend":
                window.trendDrawer.reRender();
                break;
            case "touchmove":
                event.preventDefault();
                window.trendDrawer.drawReticle(event.touches[0].clientX, event.touches[0].clientY);
                break;
        }
    }
}

/**
 * 动画显示资产配置饼图数据
 */
function animatePie() {
    var pieData = prepareAssetPieData("asset");
    var pieOptions = {
        onAnimationComplete: function () {
        }
    }
    if (undefined != window.myPie) {
        window.myPie.clear();
        window.myPie.initialize(pieData, pieOptions)
    } else {
        var ctx = document.getElementById("assets").getContext("2d");
        window.myPie = new Chart(ctx).Pie(pieData, pieOptions);
    }

    $("#assets_rate").html(buildSubText('asset'));
    myScroll.refresh();
}


function prepareAssetPieData(tag) {
    var pieData = new Array();
    switch (tag) {
        case 'asset':
        {
            var valueS = Session.assetsConfigInfo.assetAllocation.BondToNav;
            if (!isNaN(valueS)) {
                pieData.push({
                    value: valueS,
                    color: COLOR_LIST[0],
                })
            }
            valueS = Session.assetsConfigInfo.assetAllocation.CashToNav;
            if (!isNaN(valueS)) {
                pieData.push({
                    value: valueS,
                    color: COLOR_LIST[1],
                })
            }
            valueS = Session.assetsConfigInfo.assetAllocation.FundToNav;
            if (!isNaN(valueS)) {
                pieData.push({
                    value: valueS,
                    color: COLOR_LIST[2],
                })
            }

            valueS = Session.assetsConfigInfo.assetAllocation.OtherToNav;
            if (!isNaN(valueS)) {
                pieData.push({
                    value: valueS,
                    color: COLOR_LIST[3],
                })
            }

            valueS = Session.assetsConfigInfo.assetAllocation.StockToNav;
            if (!isNaN(valueS)) {
                pieData.push({
                    value: valueS,
                    color: COLOR_LIST[4],
                })
            }

            valueS = Session.assetsConfigInfo.assetAllocation.WarrantToNav;
            if (!isNaN(valueS)) {
                pieData.push({
                    value: valueS,
                    color: COLOR_LIST[5],
                })
            }
            break;
        }
        case 'industry':
        {
            var list = Session.assetsConfigInfo.industryInfo;
            $.each(list, function (index, el) {
                pieData.push({
                    value: el.industryValueToNav,
                    color: COLOR_LIST[index],
                })
            });
            break;
        }
        case 'bondType':
        {
            var list = getObjectValues(Session.assetsConfigInfo.bondTypeInfo);
            var i = 0;
            $.each(list, function (index, el) {
                if (!isNaN(el)) {
                    pieData.push({
                        value: el,
                        color: COLOR_LIST[i++],
                    })
                }
            });
            break;
        }
        case 'country':
        {
            var list = Session.assetsConfigInfo.countryInfo;
            $.each(list, function (index, el) {
                if (!isNaN(el.ratio)) {
                    pieData.push({
                        value: el.ratio,
                        color: COLOR_LIST[index],
                    })
                }
            });
            break;
        }
    }
    return pieData;
}


function buildSubText(tag) {
    var buffer = new StringBuffer();
    switch (tag) {
        case 'asset':
        {
            buffer.append("<ul class='assets-rate clearfix'>");
            var valueS = Session.assetsConfigInfo.assetAllocation.BondToNav;
            if (!isNaN(valueS)) {
                buffer.append("<li class='left'><span style='background: " + COLOR_LIST[0] + "' class='colorRect'></span><p>债券市值</p></li>");
            }
            valueS = Session.assetsConfigInfo.assetAllocation.CashToNav;
            if (!isNaN(valueS)) {
                buffer.append("<li class='left'><span style='background: " + COLOR_LIST[1] + "' class='colorRect'></span><p>银行存款</p></li>");
            }
            valueS = Session.assetsConfigInfo.assetAllocation.FundToNav;
            if (!isNaN(valueS)) {
                buffer.append("<li class='left'><span style='background: " + COLOR_LIST[2] + "' class='colorRect'></span><p>基金市值</p></li>");
            }
            valueS = Session.assetsConfigInfo.assetAllocation.OtherToNav;
            if (!isNaN(valueS)) {
                buffer.append("<li class='left'><span style='background: " + COLOR_LIST[3] + "' class='colorRect'></span><p>其他资产</p></li>");
            }
            valueS = Session.assetsConfigInfo.assetAllocation.StockToNav;
            if (!isNaN(valueS)) {
                buffer.append("<li class='left'><span style='background: " + COLOR_LIST[4] + "' class='colorRect'></span><p>股票市值</p></li>");
            }

            valueS = Session.assetsConfigInfo.assetAllocation.WarrantToNav;
            if (!isNaN(valueS)) {
                buffer.append("<li class='left'><span style='background: " + COLOR_LIST[5] + "' class='colorRect'></span><p>证券市值</p></li>");
            }
            buffer.append("</ul>");
            break;
        }
        case 'industry':
        {
            buffer.append("<ul class='assets-rate clearfix'>");
            $.each(Session.assetsConfigInfo.industryInfo, function (index, el) {
                var mo = index % 3;
                if (mo == 2) {
                    buffer.append("<li class='right'><span style='background: " + COLOR_LIST[index] + "' class='colorRect'></span><p>" + el.industryName + "</p></li>");
                } else if (mo == 1) {
                    buffer.append("<li><span style='background: " + COLOR_LIST[index] + "' class='colorRect'></span><p>" + el.industryName + "</p></li>");
                } else {
                    buffer.append("<li class='left'><span style='background: " + COLOR_LIST[index] + "' class='colorRect'></span><p>" + el.industryName + "</p></li>");
                }
            })
            buffer.append("</ul>");
            break;
        }
        case 'bondType':
        {

            break;
        }
        case 'country':
        {

            break;
        }
    }
    return buffer.toString();
}

/**
 * 绑定资产配置Tab点击切换
 */
function bindAssetTabClick() {
    $("#assets_tabs li").click(function () {
        $("#assets_tabs li a").removeClass("active");
        $(this).find("a").addClass("active");
        var tag = $(this).attr('tag');
        var pieData = prepareAssetPieData(tag);
        var pieOptions = {
            onAnimationComplete: function () {
            }
        }
        if (undefined != window.myPie) {
            window.myPie.clear();
            window.myPie.initialize(pieData)
        } else {
            var ctx = document.getElementById("assets").getContext("2d");
            window.myPie = new Chart(ctx).Pie(pieData, pieOptions);
        }

        $("#assets_rate").html(buildSubText(tag));
        myScroll.refresh();
    });
}

/**
 * 绑定非货基金走势图Tab点击切换
 */
function bindTrendTabClick() {
    $("#fund_trend_tabs li").click(function () {
        $("#fund_trend_tabs li a").removeClass("active");
        $(this).find("a").addClass("active");
        var tag = $(this).attr('tag');
        $('#hide_trend_tag').val(tag);
        if (localStorage) {
            var time = localStorage.getItem(window.windCode + CMD_CODE[2] + tag + "time");
            //三分钟缓存时间
            if (time && ((new Date().getTime() - time) / 1000 > (3 * 60))) {
                sendAjaxRequest(CMD_CODE[2], tag)
            } else {
                QueryHelper(window.windCode, CMD_CODE[2] + tag, function (value) {
                    if (undefined == value) {
                        sendAjaxRequest(CMD_CODE[2], tag)
                    } else {
                        var parsedObj = parserObject(value.data.messageBody);
                        if (parsedObj && parsedObj.dataList && parsedObj.dataList.length > 0) {
                            loadTrend(parsedObj, tag);
                        } else {
                            sendAjaxRequest(CMD_CODE[2], tag)
                        }
                    }
                });
            }
        }
    });
}

/**
 * 绑定货基走势图Tab点击切换
 */
function bindCurrencyTrendTabClick() {
    $("#cur_fund_trend_tabs li").click(function () {
        $("#cur_fund_trend_tabs li a").removeClass("active");
        $(this).find("a").addClass("active");
        var tag = $(this).attr('tag');
        $('#hide_trend_tag').val(tag);
        if (tag == "01") {
            showCurFundTrend();
        } else if (tag === "04") {
            if (undefined != window.scaleDrawer) {
                window.scaleDrawer.clear();
            }
            sendAjaxRequest(CMD_CODE[2], tag)
        }
    });
}

function loadError(reqStatus) {
    if (!isShown()) {
        $("#loading_lay").fadeOut();
        $("#loadStatus_lay").fadeIn();
    }
}